unit Matrxdlg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Grids, SysUtils, Dialogs;

type
  TEnterMatrixDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    Edit1: TEdit;
    Edit2: TEdit;
    MatrixGrid: TStringGrid;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    procedure UpdateMatrixGrid;
  public
    { Public declarations }
  end;

var
  EnterMatrixDlg: TEnterMatrixDlg;

implementation

{$R *.DFM}

procedure TEnterMatrixDlg.Edit1Change(Sender: TObject);
var i: integer;
    ErrorOc: boolean;
begin
      ErrorOc:= false;
      if Edit1.Text <> '' then
      begin
      try
      i:= StrToInt(Edit1.Text);
      Except on EConvertError do ErrorOc:= true;
      end;
      if ((ErrorOc = true) or (i <= 0) or (i > 20)) then ShowMessage('Invalid number of rows!')
      else
      begin
      MatrixGrid.RowCount:= i + 1;
      UpdateMatrixGrid;
      end;
      end;
end;

procedure TEnterMatrixDlg.Edit2Change(Sender: TObject);
var i: integer;
    ErrorOc: boolean;
begin
      ErrorOc:= false;
      if Edit2.Text <> '' then
      begin
      try
      i:= StrToInt(Edit2.Text);
      Except on EConvertError do ErrorOc:= true;
      end;
      if ((ErrorOc = true) or (i <= 0) or (i > 20)) then ShowMessage('Invalid number of columns!')
      else
      begin
      MatrixGrid.ColCount:= i + 1;
      UpdateMatrixGrid;
      end;
      end;
end;

procedure TEnterMatrixDlg.UpdateMatrixGrid;
var i, j: integer;
    s: string;
begin
     s:= '';
     with MatrixGrid do
     begin
     for I := 1 to ColCount - 1 do
     for J:= 1 to RowCount - 1 do
     Cells[I,J] := '0';
     for J:= 1 to RowCount - 1 do
     Cells[0,J] := 'Row ' + IntToStr(j);
     for J:= 1 to ColCount - 1 do
     Cells[J,0] := 'Col ' + IntToStr(j);
     end;

end;

procedure TEnterMatrixDlg.FormActivate(Sender: TObject);
begin
     UpdateMatrixGrid;
     MatrixGrid.Options:= [goEditing, goAlwaysShowEditor, goVertLine, goHorzLine, goTabs];
end;

end.
